// AvrDisassembler is a free threaded component.
// Do not instantiate from within STAs!!!!!
//
// mailto:renkoe@tbkoenig.de

// {32281402-FEDA-11D4-B258-ADDFA48AEBB0}
DEFINE_GUID(LIBID_AVRDISASSEMBLERLib,
    0x32281402, 0xFEDA, 0x11D4, 0xB2, 0x58, 0xAD, 0xDF, 0xA4, 0x8A, 0xEB, 0xB0);

// {3228140F-FEDA-11D4-B258-ADDFA48AEBB0}
DEFINE_GUID(CLSID_AvrDisassembler,
    0x3228140F, 0xFEDA, 0x11D4, 0xB2, 0x58, 0xAD, 0xDF, 0xA4, 0x8A, 0xEB, 0xB0);

// {47B7A700-FEDE-11D4-B258-ADDFA48AEBB0}
DEFINE_GUID(IID_IAvrDisassembler,
    0x47B7A700, 0xFEDE, 0x11D4, 0xB2, 0x58, 0xAD, 0xDF, 0xA4, 0x8A, 0xEB, 0xB0);


#ifndef   AVRDISASSEMBLER_H
  #define AVRDISASSEMBLER_H

    typedef enum
    {
        IFNone = 0,
        IFCall = 1,
        IFRet = 2,
        IFJmp = 4,
        IFRel = 8,
        IFCond = 16,
        IFInd = 32,
        IFExt = 64
    } InstrFlags;

    #undef  INTERFACE
    #define INTERFACE  IAvrDisassembler
    DECLARE_INTERFACE_(IAvrDisassembler, IDispatch)
    {
        STDMETHOD(QueryInterface) (THIS_ REFIID riid, PVOID* ppvObject)PURE;
        STDMETHOD_(ULONG, AddRef) (THIS)PURE;
        STDMETHOD_(ULONG, Release)(THIS)PURE;

        STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
        STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
        STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
        STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

        STDMETHOD(Init)(THIS)PURE;
        STDMETHOD(Lookup)(THIS_ unsigned char* pucData, unsigned long* pulInstrID, unsigned long* pulValid)PURE;
        STDMETHOD(Disassemble)(THIS_ unsigned char* pucData, unsigned long* pulInstrID, BSTR* pbstrStatement, BSTR* pbstrDescription, unsigned long* pulCycles, unsigned long* pulBytes, InstrFlags* peFlags, unsigned long* pulTargetAddress)PURE;
    };

#endif
